Classes:
Doctrine
Doctrine_Access
Doctrine_Adapter
Doctrine_Adapter_Db2_Exception
Doctrine_Adapter_Exception
Doctrine_Adapter_Statement
Doctrine_AuditLog
Doctrine_AuditLog_Listener
Doctrine_Collection
Doctrine_Collection_Exception
Doctrine_Collection_Iterator
Doctrine_Collection_Iterator_Expandable
Doctrine_Collection_Iterator_Normal
Doctrine_Collection_Iterator_Offset
Doctrine_Collection_Offset
Doctrine_Column
Doctrine_Compiler
Doctrine_Compiler_Exception
Doctrine_Configurable
Doctrine_Connection
Doctrine_Connection_Common
Doctrine_Connection_Db2
Doctrine_Connection_Exception
Doctrine_Connection_Firebird
Doctrine_Connection_Firebird_Exception
Doctrine_Connection_Informix
Doctrine_Connection_Informix_Exception
Doctrine_Connection_Mock
Doctrine_Connection_Module
Doctrine_Connection_Mssql
Doctrine_Connection_Mssql_Exception
Doctrine_Connection_Mysql
Doctrine_Connection_Mysql_Exception
Doctrine_Connection_Oracle
Doctrine_Connection_Oracle_Exception
Doctrine_Connection_Pgsql
Doctrine_Connection_Pgsql_Exception
Doctrine_Connection_Profiler
Doctrine_Connection_Profiler_Exception
Doctrine_Connection_Sqlite
Doctrine_Connection_Sqlite_Exception
Doctrine_Connection_Statement
Doctrine_Connection_UnitOfWork
Doctrine_DataDict
Doctrine_DataDict_Exception
Doctrine_DataDict_Informix
Doctrine_DataType
Doctrine_Db
Doctrine_Event
Doctrine_EventListener
Doctrine_EventListener_Chain
Doctrine_EventListener_Exception
Doctrine_Exception
Doctrine_Export
Doctrine_Export_Exception
Doctrine_Export_Firebird
Doctrine_Export_Frontbase
Doctrine_Export_Mssql
Doctrine_Export_Mysql
Doctrine_Export_Oracle
Doctrine_Export_Pgsql
Doctrine_Export_Reporter
Doctrine_Export_Schema
Doctrine_Export_Schema_Xml
Doctrine_Export_Schema_Yml
Doctrine_Export_Sqlite
Doctrine_Expression
Doctrine_Expression_Driver
Doctrine_Expression_Exception
Doctrine_Expression_Firebird
Doctrine_Expression_Informix
Doctrine_Expression_Mock
Doctrine_Expression_Mssql
Doctrine_Expression_Mysql
Doctrine_Expression_Oracle
Doctrine_Expression_Pgsql
Doctrine_Expression_Sqlite
Doctrine_File
Doctrine_File_Index
Doctrine_Formatter
Doctrine_Hook
Doctrine_Hook_Equal
Doctrine_Hook_Integer
Doctrine_Hook_Parser
Doctrine_Hook_Parser_Complex
Doctrine_Hook_WordLike
Doctrine_Hydrate
Doctrine_Hydrate_Array
Doctrine_Hydrate_Exception
Doctrine_Hydrate_Record
Doctrine_Import
Doctrine_Import_Builder
Doctrine_Import_Builder_BaseClass
Doctrine_Import_Builder_Exception
Doctrine_Import_Exception
Doctrine_Import_Firebird
Doctrine_Import_Informix
Doctrine_Import_Mssql
Doctrine_Import_Mysql
Doctrine_Import_Oracle
Doctrine_Import_Pgsql
Doctrine_Import_Reader
Doctrine_Import_Reader_Db
Doctrine_Import_Reader_Exception
Doctrine_Import_Reader_Xml_Propel
Doctrine_Import_Schema
Doctrine_Import_Schema_Xml
Doctrine_Import_Schema_Yml
Doctrine_Import_Sqlite
Doctrine_IntegrityMapper
Doctrine_Lib
Doctrine_Locking_Exception
Doctrine_Locking_Manager_Pessimistic
Doctrine_Manager
Doctrine_Manager_Exception
Doctrine_Node
Doctrine_Node_AdjacencyList
Doctrine_Node_AdjacencyList_LevelOrderIterator
Doctrine_Node_AdjacencyList_PostOrderIterator
Doctrine_Node_AdjacencyList_PreOrderIterator
Doctrine_Node_Exception
Doctrine_Node_MaterializedPath
Doctrine_Node_MaterializedPath_LevelOrderIterator
Doctrine_Node_MaterializedPath_PostOrderIterator
Doctrine_Node_MaterializedPath_PreOrderIterator
Doctrine_Node_NestedSet
Doctrine_Node_NestedSet_LevelOrderIterator
Doctrine_Node_NestedSet_PostOrderIterator
Doctrine_Node_NestedSet_PreOrderIterator
Doctrine_Null
Doctrine_Object
Doctrine_Plugin
Doctrine_Query
Doctrine_Query_Abstract
Doctrine_Query_Check
Doctrine_Query_Condition
Doctrine_Query_Exception
Doctrine_Query_Filter
Doctrine_Query_Filter_Chain
Doctrine_Query_From
Doctrine_Query_Groupby
Doctrine_Query_Having
Doctrine_Query_JoinCondition
Doctrine_Query_Limit
Doctrine_Query_Offset
Doctrine_Query_Orderby
Doctrine_Query_Parser
Doctrine_Query_Part
Doctrine_Query_Select
Doctrine_Query_Set
Doctrine_Query_Where
Doctrine_RawSql
Doctrine_RawSql_Exception
Doctrine_Record
Doctrine_Record_Abstract
Doctrine_Record_Exception
Doctrine_Record_Filter
Doctrine_Record_Iterator
Doctrine_Record_Listener
Doctrine_Record_Listener_Chain
Doctrine_Record_State_Exception
Doctrine_Relation
Doctrine_Relation_Association
Doctrine_Relation_Association_Self
Doctrine_Relation_Exception
Doctrine_Relation_ForeignKey
Doctrine_Relation_LocalKey
Doctrine_Relation_Nest
Doctrine_Relation_Parser
Doctrine_Relation_Parser_Exception
Doctrine_Schema
Doctrine_Schema_Column
Doctrine_Schema_Database
Doctrine_Schema_Exception
Doctrine_Schema_Object
Doctrine_Schema_Relation
Doctrine_Schema_Table
Doctrine_Search
Doctrine_Search_Analyzer
Doctrine_Search_Analyzer_Exception
Doctrine_Search_Analyzer_Standard
Doctrine_Search_Exception
Doctrine_Search_Indexer
Doctrine_Search_Indexer_Dir
Doctrine_Search_Indexer_Exception
Doctrine_Search_Listener
Doctrine_Search_Parser
Doctrine_Search_Query
Doctrine_Search_Record
Doctrine_Search_Scorer
Doctrine_Search_Template
Doctrine_Sequence
Doctrine_Sequence_Db2
Doctrine_Sequence_Exception
Doctrine_Sequence_Firebird
Doctrine_Sequence_Informix
Doctrine_Sequence_Mssql
Doctrine_Sequence_Mysql
Doctrine_Sequence_Oracle
Doctrine_Sequence_Pgsql
Doctrine_Sequence_Sqlite
Doctrine_Table
Doctrine_Table_Exception
Doctrine_Table_Repository
Doctrine_Table_Repository_Exception
Doctrine_Template
Doctrine_Template_NestedSet
Doctrine_Template_Searchable
Doctrine_Template_Taggable
Doctrine_Template_Versionable
Doctrine_Tokenizer
Doctrine_Transaction
Doctrine_Transaction_Exception
Doctrine_Transaction_Firebird
Doctrine_Transaction_Informix
Doctrine_Transaction_Mock
Doctrine_Transaction_Mssql
Doctrine_Transaction_Mysql
Doctrine_Transaction_Oracle
Doctrine_Transaction_Pgsql
Doctrine_Transaction_Sqlite
Doctrine_Tree
Doctrine_Tree_AdjacencyList
Doctrine_Tree_Exception
Doctrine_Tree_MaterializedPath
Doctrine_Tree_NestedSet
Doctrine_Util
Doctrine_Validator
Doctrine_Validator_Country
Doctrine_Validator_Creditcard
Doctrine_Validator_Date
Doctrine_Validator_Email
Doctrine_Validator_Enum
Doctrine_Validator_ErrorStack
Doctrine_Validator_Exception
Doctrine_Validator_HtmlColor
Doctrine_Validator_Ip
Doctrine_Validator_Minlength
Doctrine_Validator_Nospace
Doctrine_Validator_Notblank
Doctrine_Validator_Notnull
Doctrine_Validator_Range
Doctrine_Validator_Regexp
Doctrine_Validator_Unique
Doctrine_Validator_Unsigned
Doctrine_Validator_Usstate
Doctrine_View
Doctrine_View_Exception
Doctrine_Cache
Doctrine_Cache
Doctrine_Cache_Apc
Doctrine_Cache_Array
Doctrine_Cache_Db
Doctrine_Cache_Driver
Doctrine_Cache_Exception
Doctrine_Cache_Memcache
Doctrine_Adapter
Doctrine_Adapter_Db2
Doctrine_Adapter_Mock
Doctrine_Adapter_Mysqli
Doctrine_Adapter_Oracle
Doctrine_Adapter_Statement_Mock
Doctrine_DataDict
Doctrine_DataDict_Firebird
Doctrine_DataDict_Mssql
Doctrine_DataDict_Mysql
Doctrine_DataDict_Oracle
Doctrine_DataDict_Pgsql
Doctrine_DataDict_Sqlite

# Class: Doctrine_Manager

Source Location: /Doctrine/Manager.php

## Class Doctrine_Manager

Class Overview

Implements interfaces: Countable (internal interface) IteratorAggregate (internal interface) Doctrine_Manager is the base component of all doctrine based projects. It opens and keeps track of all connections (database connections). Located in /Doctrine/Manager.php [line 34]
    Doctrine_Object
       |
       --Doctrine_Configurable
          |
          --Doctrine_Manager
Author(s): Konsta Vesterinen <kvesteri@cc.hut.fi> Information Tags:
Version: | $Revision: 2290 $
Link: | www.phpdoctrine.com
Since: | 1.0
License: | LGPL
| Properties $driverMap $_bound $_connections $_currIndex $_index $_integrityActions $_root | Methods __construct addDeleteAction addUpdateAction bindComponent closeConnection connection contains count getComponentAlias getConnection getConnectionForComponent getConnectionName getConnections getCurrentConnection getDeleteActions getInstance getIterator getRoot getTable getUpdateActions openConnection parseDsn setComponentAlias setCurrentConnection setDefaultAttributes table __toString

[ Top ]
Inherited Properties, Constants, and Methods

Inherited Properties | Inherited Methods | Inherited Constants
--- | --- | ---
Inherited From Doctrine_Configurable Doctrine_Configurable::$attributes Doctrine_Configurable::$parent Doctrine_Configurable::$_impl Inherited From Doctrine_Object Doctrine_Object::$_null | Inherited From Doctrine_Configurable Doctrine_Configurable::addListener() addListener Doctrine_Configurable::addRecordListener() addRecordListener Doctrine_Configurable::getAttribute() returns the value of an attribute Doctrine_Configurable::getAttributes() getAttributes returns all attributes as an array Doctrine_Configurable::getCacheDriver() getCacheDriver Doctrine_Configurable::getImpl() getImpl returns the implementation for given class Doctrine_Configurable::getListener() getListener Doctrine_Configurable::getParent() getParent returns the parent of this component Doctrine_Configurable::getRecordListener() getListener Doctrine_Configurable::setAttribute() setAttribute sets a given attribute Doctrine_Configurable::setEventListener() Doctrine_Configurable::setImpl() setImpl binds given class to given template name Doctrine_Configurable::setListener() setListener Doctrine_Configurable::setParent() sets a parent for this configurable component the parent must be configurable component itself Doctrine_Configurable::setRecordListener() setListener Inherited From Doctrine_Object Doctrine_Object::getNullObject() getNullObject returns the null object associated with this object Doctrine_Object::initNullObject() initNullObject initializes the null object |

[ Top ]
Property Summary

static mixed | $driverMap |
array | $_bound |
array | $_connections |
integer | $_currIndex |
integer | $_index |
array | $_integrityActions |
string | $_root |

[ Top ]
Method Summary

static Doctrine_Connection | connection() | connection
static Doctrine_Manager | getInstance() | getInstance returns an instance of this class (this class uses the singleton pattern)
static Doctrine_Table | table() | table this is the same as Doctrine_Connection::getTable() except that it works seamlessly in multi-server/connection environment
Doctrine_Manager | __construct() | constructor
void | addDeleteAction() |
void | addUpdateAction() |
boolean | bindComponent() | bindComponent
void | closeConnection() | closes the connection
boolean | contains() | contains whether or not the manager contains specified connection
integer | count() | count returns the number of opened connections
string | getComponentAlias() | getComponentAlias
object Doctrine_Connection | getConnection() | getConnection
Doctrine_Connection | getConnectionForComponent() | getConnectionForComponent
string | getConnectionName() | getConnectionName
array | getConnections() | getConnections returns all opened connections
Doctrine_Connection | getCurrentConnection() | getCurrentConnection returns the current connection
void | getDeleteActions() |
ArrayIterator | getIterator() | getIterator returns an ArrayIterator that iterates through all connections
string | getRoot() | returns the root directory of Doctrine
Doctrine_Table | getTable() | getTable this is the same as Doctrine_Connection::getTable() except that it works seamlessly in multi-server/connection environment
void | getUpdateActions() |
Doctrine_Connection | openConnection() | openConnection opens a new connection and saves it to Doctrine_Manager->connections
array | parseDsn() | parseDsn
Doctrine_Manager | setComponentAlias() | sets an alias for given component name very useful when building a large framework with a possibility to override any given class
void | setCurrentConnection() | setCurrentConnection sets the current connection to $key
boolean | setDefaultAttributes() | setDefaultAttributes sets default attributes
string | __toString() | __toString returns a string representation of this object

[ Top ]
Properties
static mixed $driverMap = array('oci' => 'oracle') [line 62]
API Tags:

Access: | protected

[ Top ]
array $_bound = array() [line 43]
API Tags:

Access: | protected

[ Top ]
array $_connections = array() [line 39]
API Tags:

Access: | protected

[ Top ]
integer $_currIndex = 0 [line 51]
API Tags:

Access: | protected

[ Top ]
integer $_index = 0 [line 47]
API Tags:

Access: | protected

[ Top ]
array $_integrityActions = array() [line 60]
API Tags:

Access: | protected

[ Top ]
string $_root [line 55]
API Tags:

Access: | protected

[ Top ]
Methods
static method connection [line 176]

`static Doctrine_Connection connection( [PDO|Doctrine_Adapter_Interface $adapter = null], [string $name = null] )`

connection

if the adapter parameter is set this method acts as a short cut for Doctrine_Manager::getInstance()->openConnection($adapter, $name);

if the adapter paramater is not set this method acts as a short cut for Doctrine_Manager::getInstance()->getCurrentConnection()

Parameters:

PDO|Doctrine_Adapter_Interface | $adapter: | database driver
string | $name: | name of the connection, if empty numeric key is used

API Tags:

Access: | public

Information Tags:

Throws: | Doctrine_Manager_Exception if trying to bind a connection with an existing name

[ Top ]
static method getInstance [line 154]

`static Doctrine_Manager getInstance( )`

getInstance returns an instance of this class (this class uses the singleton pattern)

API Tags:

Access: | public

[ Top ]
static method table [line 446]

`static Doctrine_Table table( string $componentName )`

table this is the same as Doctrine_Connection::getTable() except that it works seamlessly in multi-server/connection environment

Parameters:

string | $componentName: |

API Tags:

See: | Doctrine_Connection::getTable()
Access: | public

[ Top ]
Constructor __construct [line 68]

`Doctrine_Manager __construct( )`

constructor

this is private constructor (use getInstance to get an instance of this class)

API Tags:

Access: | private

[ Top ]
addDeleteAction [line 74]

`void addDeleteAction( $componentName, $foreignComponent, $action )`

Parameters:

| $componentName: |
| $foreignComponent: |
| $action: |

API Tags:

Access: | public

[ Top ]
addUpdateAction [line 78]

`void addUpdateAction( $componentName, $foreignComponent, $action )`

Parameters:

| $componentName: |
| $foreignComponent: |
| $action: |

API Tags:

Access: | public

[ Top ]
bindComponent [line 407]

`boolean bindComponent( string $componentName, string $connectionName )`

bindComponent

binds given component to given connection this means that when ever the given component uses a connection it will be using the bound connection instead of the current connection

Parameters:

string | $componentName: |
string | $connectionName: |

API Tags:

Access: | public

[ Top ]
closeConnection [line 458]

`void closeConnection( Doctrine_Connection $connection )`

closes the connection

Parameters:

Doctrine_Connection | $connection: |

API Tags:

Access: | public

[ Top ]
contains [line 504]

`boolean contains( mixed $key )`

contains whether or not the manager contains specified connection

Parameters:

mixed | $key: | the connection key

API Tags:

Access: | public

[ Top ]
count [line 514]

`integer count( )`

count returns the number of opened connections

API Tags:

Access: | public

Implementation of:

Countable::count

[ Top ]
getComponentAlias [line 364]

`string getComponentAlias( string $componentName )`

getComponentAlias

retrieves the alias for given component name if the alias couldn't be found, this method returns the given component name

Parameters:

string | $componentName: |

API Tags:

Return: | the component alias
Access: | public

[ Top ]
getConnection [line 347]

`object Doctrine_Connection getConnection( $name, integer $index )`

getConnection

Parameters:

integer | $index: |
| $name: |

API Tags:

Access: | public

Information Tags:

Throws: | Doctrine_Manager_Exception if trying to get a non-existent connection

[ Top ]
getConnectionForComponent [line 417]

`Doctrine_Connection getConnectionForComponent( [string $componentName = null] )`

getConnectionForComponent

Parameters:

string | $componentName: |

API Tags:

Access: | public

[ Top ]
getConnectionName [line 393]

`string getConnectionName( Doctrine_Connection $conn )`

getConnectionName

Parameters:

Doctrine_Connection | $conn: | connection object to be searched for

API Tags:

Return: | the name of the connection
Access: | public

[ Top ]
getConnections [line 477]

`array getConnections( )`

getConnections returns all opened connections

API Tags:

Access: | public

[ Top ]
getCurrentConnection [line 535]

`Doctrine_Connection getCurrentConnection( )`

getCurrentConnection returns the current connection

API Tags:

Access: | public

Information Tags:

Throws: | Doctrine_Connection_Exception if there are no open connections

[ Top ]
getDeleteActions [line 82]

`void getDeleteActions( $componentName )`

Parameters:

| $componentName: |

API Tags:

Access: | public

[ Top ]
getIterator [line 524]

`ArrayIterator getIterator( )`

getIterator returns an ArrayIterator that iterates through all connections

API Tags:

Access: | public

Implementation of:

IteratorAggregate::getIterator

[ Top ]
getRoot [line 143]

`string getRoot( )`

returns the root directory of Doctrine

API Tags:

Access: | public

[ Top ]
getTable [line 433]

`Doctrine_Table getTable( string $componentName )`

getTable this is the same as Doctrine_Connection::getTable() except that it works seamlessly in multi-server/connection environment

Parameters:

string | $componentName: |

API Tags:

See: | Doctrine_Connection::getTable()
Access: | public

[ Top ]
getUpdateActions [line 90]

`void getUpdateActions( $componentName )`

Parameters:

| $componentName: |

API Tags:

Access: | public

[ Top ]
openConnection [line 194]

`Doctrine_Connection openConnection( PDO|Doctrine_Adapter_Interface $adapter, [string $name = null], [ $setCurrent = true] )`

openConnection opens a new connection and saves it to Doctrine_Manager->connections

Parameters:

PDO|Doctrine_Adapter_Interface | $adapter: | database driver
string | $name: | name of the connection, if empty numeric key is used
| $setCurrent: |

API Tags:

Access: | public

Information Tags:

Throws: | Doctrine_Manager_Exception if trying to open connection for unknown driver
Throws: | Doctrine_Manager_Exception if trying to bind a connection with an existing name

[ Top ]
parseDsn [line 270]

`array parseDsn( string $dsn )`

parseDsn

Parameters:

string | $dsn: |

API Tags:

Return: | Parsed contents of DSN
Access: | public

[ Top ]
setComponentAlias [line 381]

`Doctrine_Manager setComponentAlias( string $componentName, string $alias )`

sets an alias for given component name very useful when building a large framework with a possibility to override any given class

Parameters:

string | $componentName: | the name of the component
string | $alias: |

API Tags:

Access: | public

[ Top ]
setCurrentConnection [line 489]

`void setCurrentConnection( mixed $key )`

setCurrentConnection sets the current connection to $key

Parameters:

mixed | $key: | the connection key

API Tags:

Access: | public

Information Tags:

Throws: | InvalidKeyException

[ Top ]
setDefaultAttributes [line 104]

`boolean setDefaultAttributes( )`

setDefaultAttributes sets default attributes

API Tags:

Access: | public

[ Top ]
__toString [line 549]

`string __toString( )`

__toString returns a string representation of this object

API Tags:

Access: | public

[ Top ]